from cpl_core.application import StartupExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceCollectionABC
from cpl_core.environment import ApplicationEnvironmentABC

from bot_data.abc.migration_abc import MigrationABC
from bot_data.migration.initial_migration import InitialMigration
from bot_data.service.migration_service import MigrationService


class StartupMigrationExtension(StartupExtensionABC):

    def __init__(self):
        pass

    def configure_configuration(self, config: ConfigurationABC, env: ApplicationEnvironmentABC):
        pass

    def configure_services(self, services: ServiceCollectionABC, env: ApplicationEnvironmentABC):
        services.add_transient(MigrationService)
        services.add_transient(MigrationABC, InitialMigration)
